SystemOrganization addCategory: #ConfigurationOfFileTree!

Object subclass: #ConfigurationOfFileTree
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfFileTree'!

!ConfigurationOfFileTree class methodsFor: 'development support' stamp: 'dkh 1/30/2012 09:45'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfFileTree class methodsFor: 'private' stamp: 'dkh 1/30/2012 09:45'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfFileTree class methodsFor: 'private' stamp: 'dkh 1/30/2012 09:45'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfFileTree class methodsFor: 'private' stamp: 'dkh 1/30/2012 09:45'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfFileTree class methodsFor: 'metacello tool support' stamp: 'dkh 1/30/2012 09:45'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfFileTree class methodsFor: 'loading' stamp: 'dkh 1/30/2012 09:45'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfFileTree class methodsFor: 'loading' stamp: 'dkh 1/30/2012 09:45'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfFileTree class methodsFor: 'loading' stamp: 'dkh 1/30/2012 09:45'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfFileTree class methodsFor: 'accessing' stamp: 'dkh 1/30/2012 09:45'!
project

	^self new project! !

!ConfigurationOfFileTree class methodsFor: 'development support' stamp: 'dkh 1/30/2012 09:45'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfFileTree methodsFor: 'baselines' stamp: 'dkh 1/30/2012 09:53'!
baseline100: spec
    <version: '1.0-baseline'>
    spec
        for: #'common'
        do: [ 
            spec blessing: #'baseline'.
            spec package: 'MonticelloFileTree'.
            spec group: 'default' with: #('MonticelloFileTree') ].
    spec
        for: #'gemstone'
        do: [ 
            spec package: 'MonticelloFileTree' with: [ spec includes: 'MonticelloFileTree-GemStone-Extensions' ].
            spec package: 'MonticelloFileTree-GemStone-Extensions' with: [ spec requires: 'MonticelloFileTree' ] ]! !

!ConfigurationOfFileTree methodsFor: 'accessing' stamp: 'dkh 1/30/2012 09:45'!
customProjectAttributes
    "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes "

    ^ #()! !

!ConfigurationOfFileTree methodsFor: 'symbolic versions' stamp: 'dkh 1/30/2012 15:14'!
development: spec
    <symbolicVersion: #'development'>
    spec for: #'common' version: '1.0'! !

!ConfigurationOfFileTree methodsFor: 'accessing' stamp: 'dkh 1/30/2012 09:45'!
project
    ^ project
        ifNil: [ 
            "Bootstrap Metacello if it is not already loaded"
            self class ensureMetacello.
            project := MetacelloMCProject new projectAttributes: self customProjectAttributes.	"Create the Metacello project"
            (Smalltalk at: #'MetacelloVersionConstructor') on: self project: project.	"Construct the project"
            project loadType: #'linear'.	"change to #atomic if desired"
            project ]! !

!ConfigurationOfFileTree methodsFor: 'versions' stamp: 'dkh 1/30/2012 20:13'!
version100: spec
	<version: '1.0' imports: #('1.0-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #development.
			spec
				description:
					'1.0 (dkh.2):
- change the description for FileTree repository to filetree:// to be consistent with other Metacello descriptions...
1.0 (dkh.3):
- missing methods needed to run in Pharo1.3 #13315
1,0 (dkh.4)
- fix Issue 13: Monticello branches not handled correctly
  https://github.com/finworks/smallsource/issues/13'.
			spec author: 'dkh'.
			spec timestamp: '1/30/2012 20:13'.
			spec package: 'MonticelloFileTree' with: 'MonticelloFileTree-dkh.57' ].
	spec
		for: #gemstone
		do: [ spec package: 'MonticelloFileTree-GemStone-Extensions' with: 'MonticelloFileTree-GemStone-Extensions-revelations.11' ]! !
